Attribute VB_Name = "modDatabase"
' Copied from 'http://www.vb6.us/tutorials/visual-basic-combo-box-tutorial'
' Modified by SK HEO                        02/09/2011

Option Explicit

Public gobjConn                    As ADODB.Connection
Public gobjCmd                     As ADODB.Command
Public gobjRst                     As ADODB.Recordset

Public Sub InitializeDB()
    Dim tmp As String
    tmp = Dir(GetAppPath & "*.mdb")
    
    
    Set gobjConn = New ADODB.Connection
    gobjConn.Open "Provider=Microsoft.Jet.OLEDB.4.0;" & "Data Source=" & GetAppPath & tmp
    Set gobjCmd = New ADODB.Command
    Set gobjCmd.ActiveConnection = gobjConn
    gobjCmd.CommandType = adCmdText

End Sub

Public Sub DisconnectDB()
    
    gobjConn.Close
    Set gobjCmd = Nothing
    Set gobjConn = Nothing

End Sub


Public Function GetAppPath() As String

    Dim strAppPath As String
    strAppPath = App.Path
    If Right$(strAppPath, 1) <> "\" Then
        strAppPath = strAppPath & "\"
    End If
    GetAppPath = strAppPath

End Function


Public Sub LoadDataField()                  '// SK
   
    Dim objRstDropDownData  As ADODB.Recordset
    Dim strSQL              As String
    Dim i                   As Integer
    
    strSQL = ""
    strSQL = strSQL & "SELECT * "
    strSQL = strSQL & "  FROM " & gstrATCDBTableName
    
    gobjCmd.CommandText = strSQL
    
    Set objRstDropDownData = gobjCmd.Execute
    
    i = 0
    ' Read database
    Do Until objRstDropDownData.EOF
        If SelectedPart = objRstDropDownData.Fields(0) Then
            RFPartName = objRstDropDownData.Fields(0)
            ParallelOrSerial = objRstDropDownData.Fields(1)
            NumBits1 = objRstDropDownData.Fields(2)
            NumBits2 = objRstDropDownData.Fields(3)
            LowHighActive = objRstDropDownData.Fields(4)
            MSBorLSB = objRstDropDownData.Fields(5)
            SW1_Enable = objRstDropDownData.Fields(6)
            SW2_Enable = objRstDropDownData.Fields(7)
            SW3_Enable = objRstDropDownData.Fields(8)
            SW4_Enable = objRstDropDownData.Fields(9)
            D(0) = objRstDropDownData.Fields(10)
            D(1) = objRstDropDownData.Fields(11)
            D(2) = objRstDropDownData.Fields(12)
            D(3) = objRstDropDownData.Fields(13)
            D(4) = objRstDropDownData.Fields(14)
            D(5) = objRstDropDownData.Fields(15)
            D(6) = objRstDropDownData.Fields(16)
            D(7) = objRstDropDownData.Fields(17)
            Chip_Addr = objRstDropDownData.Fields(18)
            Reg_Addr = objRstDropDownData.Fields(19)
            Min_Value1 = objRstDropDownData.Fields(20)
            Max_Value1 = objRstDropDownData.Fields(21)
            Min_Value2 = objRstDropDownData.Fields(22)
            Max_Value2 = objRstDropDownData.Fields(23)
            AttenValBox1Label = objRstDropDownData.Fields(24)
            AttenValBox2Label = objRstDropDownData.Fields(25)
            AttenValBox1Units = objRstDropDownData.Fields(26)
            AttenValBox2Units = objRstDropDownData.Fields(27)
            Exit Do
        End If
        objRstDropDownData.MoveNext
        i = i + 1
    Loop
   
  
    BitStep1 = (Max_Value1 - Min_Value1) / (2 ^ NumBits1 - 1)
    If NumBits2 <> 0 Then BitStep2 = (Max_Value2 - Min_Value2) / (2 ^ NumBits2 - 1)
    
    BitMax1 = (2 ^ NumBits1) - 1
    BitMax2 = (2 ^ NumBits2) - 1
    
    
    i = 0
    
    'load Values Array.  use this array to update GUI for up/down buttons or direct entry (round to nearest value)
    Do While i <= (BitMax1)
        GUI_Values1(i) = Min_Value1 + BitStep1 * i
        GUI_Values1(i) = Round(GUI_Values1(i), 2)
        i = i + 1
    Loop
    
    i = 0
    
    Do While i <= (BitMax2)
        GUI_Values2(i) = Min_Value2 + BitStep2 * i
        GUI_Values2(i) = Round(GUI_Values2(i), 2)
        i = i + 1
    Loop
    
    objRstDropDownData.Close
    
    Set objRstDropDownData = Nothing

End Sub
